Index: /profile/src/test/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpaceTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpaceTest.java	(revision 9)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpaceTest.java	(revision 9)
@@ -0,0 +1,308 @@
+package geniusweb.profile.utilityspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.math.BigInteger;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.nio.file.Paths;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.stream.Collectors;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.DiscreteValueSet;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.Value;
+import geniusweb.issuevalue.ValueSet;
+import geniusweb.profile.Profile;
+import tudelft.utilities.immutablelist.AbstractImmutableList;
+import tudelft.utilities.immutablelist.ImmutableList;
+import tudelft.utilities.immutablelist.Outer;
+
+public class SumOfGroupsUtilitySpaceTest {
+	private final ObjectMapper jackson = new ObjectMapper();
+	private SumOfGroupsUtilitySpace pa1;
+	private final String iss1 = "issue1", iss2 = "issue2", iss3 = "issue3";
+	private static BigDecimal N01 = new BigDecimal("0.1"),
+			N02 = new BigDecimal("0.2"), N03 = new BigDecimal("0.3"),
+			N05 = new BigDecimal("0.5"), N07 = new BigDecimal("0.7"),
+			N08 = new BigDecimal("0.8"), N09 = new BigDecimal("0.9");
+
+	private final DiscreteValue lo = new DiscreteValue("low");
+	private final DiscreteValue hi = new DiscreteValue("high");
+	private final Bid resBid = new Bid(iss1, hi);
+
+	private Domain domain;
+	private PartsUtilities putils12, putils3;
+	private String serialized = "{\"SumOfGroupsUtilitySpace\":{\"domain\":{\"name\":\"domain\",\"issuesValues\":{\"issue3\":{\"values\":[\"low\",\"high\"]},\"issue2\":{\"values\":[\"low\",\"high\"]},\"issue1\":{\"values\":[\"low\",\"high\"]}}},\"name\":\"testspace\",\"partUtilities\":{\"1and2\":{\"partsutils\":{\"issues\":[\"issue1\",\"issue2\"],\"utilslist\":[{\"values\":[\"low\",\"low\"],\"util\":0.16},{\"values\":[\"high\",\"high\"],\"util\":0.72},{\"values\":[\"low\",\"high\"],\"util\":0.16},{\"values\":[\"high\",\"low\"],\"util\":0.16}]}},\"3\":{\"partsutils\":{\"issues\":[\"issue3\"],\"utilslist\":[{\"values\":[\"low\"],\"util\":0.16},{\"values\":[\"high\"],\"util\":0.14}]}}},\"reservationbid\":{\"issuevalues\":{\"issue1\":\"high\"}}}}";
+
+	@Before
+	public void before() {
+		Map<String, ValueSet> issues = new HashMap<>();
+		issues.put(iss1, new DiscreteValueSet(lo, hi));
+		issues.put(iss2, new DiscreteValueSet(lo, hi));
+		issues.put(iss3, new DiscreteValueSet(lo, hi));
+		domain = new Domain("domain", issues);
+
+		Map<ProductOfValue, BigDecimal> utils12 = new HashMap<>();
+		// util12 has weight N08
+		utils12.put(new ProductOfValue(Arrays.asList(lo, lo)),
+				N02.multiply(N08));
+		utils12.put(new ProductOfValue(Arrays.asList(lo, hi)),
+				N02.multiply(N08));
+		utils12.put(new ProductOfValue(Arrays.asList(hi, lo)),
+				N02.multiply(N08));
+		utils12.put(new ProductOfValue(Arrays.asList(hi, hi)),
+				N09.multiply(N08));
+		putils12 = new PartsUtilities(Arrays.asList(iss1, iss2), utils12);
+
+		// utils3 has weight N02.
+		Map<ProductOfValue, BigDecimal> utils3 = new HashMap<>();
+		utils3.put(new ProductOfValue(Arrays.asList(lo)), N08.multiply(N02));
+		utils3.put(new ProductOfValue(Arrays.asList(hi)), N07.multiply(N02));
+		putils3 = new PartsUtilities(Arrays.asList(iss3), utils3);
+
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void smokeTestIncompleteProfile() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		new SumOfGroupsUtilitySpace(domain, "testspace", partutils, resBid);
+
+	}
+
+	@Test // non-normalized utils should be fine in this case
+	public void smokeTestWeightsNotNormalized() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		partutils.put("3", putils3);
+		new SumOfGroupsUtilitySpace(domain, "testspace", partutils, resBid);
+
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void smokeTestExtraIssue() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		partutils.put("3", putils3);
+		partutils.put("4", putils3);
+		new SumOfGroupsUtilitySpace(domain, "testspace", partutils, resBid);
+
+	}
+
+	@Test
+	public void smokeTest() {
+		makeBasic();
+	}
+
+	@Test
+	public void testName() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertEquals("testspace", paus.getName());
+	}
+
+	@Test
+	public void testDomain() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertEquals(domain, paus.getDomain());
+	}
+
+	@Test
+	public void testGetResBid() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertEquals(resBid, paus.getReservationBid());
+	}
+
+	@Test
+	public void testGetUtilityEmptyBid() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		assertTrue(BigDecimal.ZERO.compareTo(
+				paus.getUtility(new Bid(Collections.emptyMap()))) == 0);
+	}
+
+	@Test
+	public void testGetUtility() {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		Map<String, Value> map = new HashMap<>();
+		map.put(iss1, lo);
+		map.put(iss2, lo); // 1,2 combined has util 0.2
+		map.put(iss3, hi); // 3 has util 0.7
+		// weights are set to 0.8, 0.2. Gives total util 0.3
+		Bid bid = new Bid(map);
+		assertTrue(N03.compareTo(paus.getUtility(bid)) == 0);
+	}
+
+	/**
+	 * Demonstrates how to convert {@link LinearAdditiveUtilitySpace} to a
+	 * {@link SumOfGroupsUtilitySpace}
+	 * 
+	 */
+	@Test
+	public void testConvertLas() throws IOException {
+		String profile = new String(
+				Files.readAllBytes(Paths.get("src/test/resources/party1.json")),
+				StandardCharsets.UTF_8);
+		LinearAdditiveUtilitySpace las = jackson.readValue(profile,
+				LinearAdditiveUtilitySpace.class);
+		SumOfGroupsUtilitySpace pas = new SumOfGroupsUtilitySpace(las);
+		checkUtilitiesAllEqual(las, pas);
+		System.out.println("Generated partial profile:\n" + pas);
+	}
+
+	/**
+	 * Demonstrates how to convert {@link LinearAdditiveUtilitySpace} to a
+	 * {@link SumOfGroupsUtilitySpace} and group some issues
+	 * 
+	 */
+	@Test
+	public void testConvertAndGroupParty() throws IOException {
+		String profile = new String(
+				Files.readAllBytes(Paths.get("src/test/resources/party1.json")),
+				StandardCharsets.UTF_8);
+		LinearAdditiveUtilitySpace las = jackson.readValue(profile,
+				LinearAdditiveUtilitySpace.class);
+		SumOfGroupsUtilitySpace pas = new SumOfGroupsUtilitySpace(las);
+		pas = pas.group(Arrays.asList("Food", "Drinks"), "food&drinks");
+		checkUtilitiesAllEqual(las, pas);
+		System.out.println("Re-grouped party profile:\n");
+		System.out.println(jackson.writeValueAsString(pas));
+
+	}
+
+	@Test
+	public void testGroupe2e() {
+		Map<ProductOfValue, BigDecimal> utils1 = new HashMap<>();
+		utils1.put(new ProductOfValue(Arrays.asList(lo)), N02.multiply(N02));
+		utils1.put(new ProductOfValue(Arrays.asList(hi)), N03.multiply(N02));
+		Map<ProductOfValue, BigDecimal> utils2 = new HashMap<>();
+		utils2.put(new ProductOfValue(Arrays.asList(lo)), N07.multiply(N03));
+		utils2.put(new ProductOfValue(Arrays.asList(hi)), N02.multiply(N03));
+		Map<ProductOfValue, BigDecimal> utils3 = new HashMap<>();
+		utils3.put(new ProductOfValue(Arrays.asList(lo)), N05.multiply(N05));
+		utils3.put(new ProductOfValue(Arrays.asList(hi)), N08.multiply(N05));
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put(iss1, new PartsUtilities(Arrays.asList(iss1), utils1));
+		partutils.put(iss2, new PartsUtilities(Arrays.asList(iss2), utils2));
+		partutils.put(iss3, new PartsUtilities(Arrays.asList(iss3), utils3));
+
+		Map<String, ValueSet> issvalues = new HashMap<>();
+		issvalues.put(iss1, new DiscreteValueSet(lo, hi));
+		issvalues.put(iss2, new DiscreteValueSet(lo, hi));
+		issvalues.put(iss3, new DiscreteValueSet(lo, hi));
+		Domain domain1 = new Domain("test", issvalues);
+
+		SumOfGroupsUtilitySpace pas = new SumOfGroupsUtilitySpace(domain1,
+				"testspace", partutils, resBid);
+
+		SumOfGroupsUtilitySpace pasgrouped12 = pas
+				.group(Arrays.asList(iss1, iss2), "iss12");
+
+		checkEqualUtilities(pas, pasgrouped12);
+
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		SumOfGroupsUtilitySpace paus = makeBasic();
+		ObjectMapper jackson = new ObjectMapper();
+		String string = jackson.writeValueAsString(paus);
+		System.out.println(string);
+		assertEquals(serialized, string);
+
+	}
+
+	@Test
+	public void testDeserialize() throws IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		assertEquals(makeBasic(), jackson.readValue(serialized, Profile.class));
+
+	}
+
+	/************************ PRIVATE FUNCTIONS *******************/
+
+	private void checkEqualUtilities(UtilitySpace space1, UtilitySpace space2) {
+		for (Bid bid : new MyAllBidsList(space1.getDomain())) {
+			assertEquals(space1.getUtility(bid), space2.getUtility(bid));
+		}
+	}
+
+	private SumOfGroupsUtilitySpace makeBasic() {
+		HashMap<String, PartsUtilities> partutils = new HashMap<>();
+		partutils.put("1and2", putils12);
+		partutils.put("3", putils3);
+		return new SumOfGroupsUtilitySpace(domain, "testspace", partutils,
+				resBid);
+
+	}
+
+	private void checkUtilitiesAllEqual(UtilitySpace space1,
+			UtilitySpace space2) {
+		for (Bid bid : new MyAllBidsList(space1.getDomain())) {
+			assertTrue(space1.getUtility(bid)
+					.compareTo(space2.getUtility(bid)) == 0);
+		}
+	}
+
+}
+
+/**
+ * Copy of AllBidsList. We can not depend on BidSpace because that would cause a
+ * cyclic dependency.
+ */
+class MyAllBidsList extends AbstractImmutableList<Bid> {
+
+	private final List<String> issues;
+	private final Outer<? extends Value> allValuePermutations;
+
+	/**
+	 * A list containing all bids in the space. This is an ImmutableList so it
+	 * can contain all bids without pre-computing them.
+	 * 
+	 */
+	public MyAllBidsList(Domain domain) {
+		if (domain == null)
+			throw new IllegalArgumentException("domain=null");
+		issues = new ArrayList<>(domain.getIssues());
+
+		List<ImmutableList<Value>> values = issues.stream()
+				.map(issue -> domain.getValues(issue))
+				.collect(Collectors.toList());
+
+		allValuePermutations = new Outer<Value>(values);
+	}
+
+	@Override
+	public Bid get(BigInteger index) {
+		ImmutableList<? extends Value> nextValues = allValuePermutations
+				.get(index);
+
+		Map<String, Value> issueValues = new HashMap<>();
+		for (int n = 0; n < issues.size(); n++) {
+			issueValues.put(issues.get(n),
+					nextValues.get(BigInteger.valueOf(n)));
+		}
+		return new Bid(issueValues);
+	}
+
+	@Override
+	public BigInteger size() {
+		return allValuePermutations.size();
+	}
+
+}
Index: /profileconnection/src/main/java/geniusweb/profileconnection/FileProfileConnector.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/FileProfileConnector.java	(revision 8)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/FileProfileConnector.java	(revision 9)
@@ -10,9 +10,11 @@
 
 import geniusweb.profile.Profile;
+import tudelft.utilities.listener.DefaultListenable;
 
 /**
  * ProfileInterface based on a plain filesystem UTF8 file.
  */
-public class FileProfileConnector implements ProfileInterface {
+public class FileProfileConnector extends DefaultListenable<Profile>
+		implements ProfileInterface {
 	private final static ObjectMapper jackson = new ObjectMapper();
 	private final Profile profile;
@@ -25,5 +27,6 @@
 	public FileProfileConnector(String filename) throws IOException {
 		Path path = new File(filename).toPath();
-		String serialized = new String(Files.readAllBytes(path), StandardCharsets.UTF_8);
+		String serialized = new String(Files.readAllBytes(path),
+				StandardCharsets.UTF_8);
 		profile = jackson.readValue(serialized, Profile.class);
 	}
Index: /profileconnection/src/main/java/geniusweb/profileconnection/ProfileInterface.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/ProfileInterface.java	(revision 8)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/ProfileInterface.java	(revision 9)
@@ -2,9 +2,10 @@
 
 import geniusweb.profile.Profile;
+import tudelft.utilities.listener.Listenable;
 
 /**
  * A container holding a modifyable profile. This interface allows testing.
  */
-public interface ProfileInterface {
+public interface ProfileInterface extends Listenable<Profile> {
 
 	/**
Index: /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 8)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 9)
@@ -15,4 +15,5 @@
 
 import geniusweb.profile.Profile;
+import tudelft.utilities.listener.DefaultListenable;
 import tudelft.utilities.logging.Reporter;
 
@@ -21,5 +22,6 @@
  */
 @ClientEndpoint
-public class WebsocketProfileConnector implements ProfileInterface {
+public class WebsocketProfileConnector extends DefaultListenable<Profile>
+		implements ProfileInterface {
 	private final static ObjectMapper jackson = new ObjectMapper();
 	private static final int TIMEOUT_MS = 2000;
@@ -56,5 +58,6 @@
 		// this will be called every time the profile changes.
 		logger.log(Level.FINE, "Received profile: " + message);
-		this.profile = jackson.readValue(message, Profile.class);
+		profile = jackson.readValue(message, Profile.class);
+		notifyListeners(profile);
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/NegoProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/NegoProtocol.java	(revision 8)
+++ /protocol/src/main/java/geniusweb/protocol/NegoProtocol.java	(revision 9)
@@ -10,5 +10,5 @@
 import geniusweb.events.CurrentState;
 import geniusweb.events.ProtocolEvent;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -70,9 +70,9 @@
 	 * 
 	 * 
-	 * @param connectionfactory the {@link ConnectionWithPartyFactory} that allows
+	 * @param connectionfactory the {@link ProtocolToPartyConnFactory} that allows
 	 *                          the protocol to connect with the {@link Reference}s
 	 *                          in the settings
 	 */
-	void start(ConnectionWithPartyFactory connectionfactory);
+	void start(ProtocolToPartyConnFactory connectionfactory);
 
 	/**
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConn.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConn.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConn.java	(revision 9)
@@ -0,0 +1,19 @@
+package geniusweb.protocol.partyconnection;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.connection.ConnectionEnd;
+import geniusweb.party.inform.Inform;
+
+/**
+ * Connection of the protocol with a party. Note, this is the opposite direction
+ * of a connection of the party with the protocol.
+ */
+public interface ProtocolToPartyConn extends ConnectionEnd<Action, Inform> {
+
+	/**
+	 * 
+	 * @return the partyId of the party that this connects to
+	 */
+	PartyId getParty();
+}
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java	(revision 9)
@@ -0,0 +1,39 @@
+package geniusweb.protocol.partyconnection;
+
+import java.io.IOException;
+import java.util.List;
+
+import geniusweb.actions.Action;
+import geniusweb.connection.ConnectionFactory;
+import geniusweb.party.inform.Inform;
+import geniusweb.references.Reference;
+import tudelft.utilities.repository.NoResourcesNowException;
+
+/**
+ * An extended {@link ConnectionFactory} that store PartyIDs with the
+ * connections, making it possible to find back the appropriate connection given
+ * a PartyID. Also, it allows the connection factory to actually assign the
+ * PartyIDs.
+ *
+ */
+public interface ProtocolToPartyConnFactory
+		extends ConnectionFactory<Action, Inform> {
+	@Override
+	public ProtocolToPartyConn connect(Reference reference)
+			throws IOException, NoResourcesNowException;
+
+	/**
+	 * Connects a set of References in one go, following a modified Banker's
+	 * algorthm.
+	 * 
+	 * @param references the list of references to connect with
+	 * @return a List of connections, one fore each Reference.
+	 * @throws IOException             if a connection is failing irrecoverably.
+	 * @throws NoResourcesNowException is there are insufficient resources now.
+	 *                                 This also includes a suggested moment to
+	 *                                 retry.
+	 */
+	List<ProtocolToPartyConn> connect(List<Reference> references)
+			throws IOException, NoResourcesNowException;
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java	(revision 9)
@@ -0,0 +1,123 @@
+package geniusweb.protocol.partyconnection;
+
+import java.io.IOException;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.stream.Collectors;
+import java.util.stream.Stream;
+
+import geniusweb.actions.PartyId;
+import geniusweb.party.inform.Inform;
+
+/**
+ * Contains all parties with their connections. immutable
+ */
+public class ProtocolToPartyConnections implements Iterable<ProtocolToPartyConn> {
+	private List<ProtocolToPartyConn> connections;
+
+	public ProtocolToPartyConnections(List<ProtocolToPartyConn> connections) {
+		this.connections = connections;
+	}
+
+	/**
+	 * @param id the {@link PartyId} needed
+	 * @return a connection with that party, or null if no such connection.
+	 */
+	public ProtocolToPartyConn get(PartyId id) {
+		return connections.stream().filter(conn -> id.equals(conn.getParty()))
+				.findAny().orElse(null);
+	}
+
+	/**
+	 * 
+	 * @return true iff all parties have one connection only
+	 */
+	public boolean allunique() {
+		return getParties().size() == connections.size();
+	}
+
+	/**
+	 * 
+	 * @return list of parties currently in the connections.
+	 */
+	private List<PartyId> getParties() {
+		return connections.stream().map(conn -> conn.getParty()).distinct()
+				.collect(Collectors.toList());
+	}
+
+	/**
+	 * Broadcast info to all parties
+	 * 
+	 * @param info the {@link Inform} to broadcast
+	 */
+	public void broadcast(Inform info) throws IOException {
+		for (ProtocolToPartyConn conn : connections) {
+			conn.send(info);
+		}
+	}
+
+	/**
+	 * 
+	 * @return number of connections available
+	 */
+	public int size() {
+		return connections.size();
+	}
+
+	/**
+	 * @param i
+	 * @return the ith connection
+	 */
+	public ProtocolToPartyConn get(int i) {
+		return connections.get(i);
+	}
+
+	public Stream<ProtocolToPartyConn> stream() {
+		return connections.stream();
+	}
+
+	@Override
+	public Iterator<ProtocolToPartyConn> iterator() {
+		return connections.iterator();
+	}
+
+	public ProtocolToPartyConnections with(ProtocolToPartyConn conn) {
+		List<ProtocolToPartyConn> newconnections = new LinkedList<>(
+				connections);
+		newconnections.add(conn);
+		return new ProtocolToPartyConnections(newconnections);
+	}
+
+	@Override
+	public String toString() {
+		return "ConnectionWithParties" + connections;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((connections == null) ? 0 : connections.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		ProtocolToPartyConnections other = (ProtocolToPartyConnections) obj;
+		if (connections == null) {
+			if (other.connections != null)
+				return false;
+		} else if (!connections.equals(other.connections))
+			return false;
+		return true;
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 8)
+++ /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 9)
@@ -10,5 +10,5 @@
 import geniusweb.progress.Progress;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithParties;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.references.PartyWithProfile;
 
@@ -19,5 +19,5 @@
 	private final List<Action> actions;
 
-	private final transient ConnectionWithParties connections;
+	private final transient ProtocolToPartyConnections connections;
 
 	private final Progress progress;
@@ -60,5 +60,5 @@
 	 */
 	public DefaultSessionState(List<Action> actions,
-			ConnectionWithParties conns, Progress progr,
+			ProtocolToPartyConnections conns, Progress progr,
 			SessionSettings settings,
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
@@ -67,5 +67,5 @@
 		}
 		if (conns == null) {
-			this.connections = new ConnectionWithParties(
+			this.connections = new ProtocolToPartyConnections(
 					Collections.EMPTY_LIST);
 		} else {
@@ -92,5 +92,5 @@
 	 * @return existing connections.
 	 */
-	public ConnectionWithParties getConnections() {
+	public ProtocolToPartyConnections getConnections() {
 		return connections;
 	}
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 8)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 9)
@@ -23,6 +23,6 @@
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -95,5 +95,5 @@
 	@Override
 	public synchronized void start(
-			ConnectionWithPartyFactory connectionfactory) {
+			ProtocolToPartyConnFactory connectionfactory) {
 
 		try {
@@ -151,5 +151,5 @@
 	 */
 	protected synchronized void connect(
-			ConnectionWithPartyFactory connectionfactory)
+			ProtocolToPartyConnFactory connectionfactory)
 			throws InterruptedException, IOException {
 		List<PartyWithProfile> participants = state.getSettings()
@@ -158,5 +158,5 @@
 				.map(parti -> (parti.getParty().getPartyRef()))
 				.collect(Collectors.toList());
-		List<ConnectionWithParty> connections = null;
+		List<ProtocolToPartyConn> connections = null;
 		log.log(Level.INFO, "SAOP connect " + parties);
 		while (connections == null) {
@@ -218,9 +218,9 @@
 	 */
 	protected synchronized void setupParties() throws ProtocolException {
-		for (ConnectionWithParty conn : state.getConnections()) {
+		for (ProtocolToPartyConn conn : state.getConnections()) {
 			conn.addListener(action -> actionRequest(conn, action));
 		}
 
-		for (ConnectionWithParty connection : state.getConnections()) {
+		for (ProtocolToPartyConn connection : state.getConnections()) {
 			try {
 				sendSettings(connection);
@@ -239,5 +239,5 @@
 	 * @throws IOException if party got disconnected
 	 */
-	private synchronized void sendSettings(ConnectionWithParty connection)
+	private synchronized void sendSettings(ProtocolToPartyConn connection)
 			throws IOException {
 		PartyId partyid = connection.getParty();
@@ -261,9 +261,13 @@
 	 */
 	protected synchronized void actionRequest(
-			final ConnectionWithParty partyconn, final Action action) {
+			final ProtocolToPartyConn partyconn, final Action action) {
 		if (action == null) {
-			handleError(partyconn
-					+ " did null action, breaching the protocol. Closing session",
-					partyconn.getParty().getName(), null);
+			Throwable err = partyconn.getError();
+			if (err == null) {
+				err = new ProtocolException("Party sent a null action",
+						partyconn.getParty().getName());
+			}
+			handleError(partyconn + "Protocol error",
+					partyconn.getParty().getName(), err);
 			return;
 		}
@@ -348,11 +352,11 @@
 			return;
 		Inform finished = new Finished(state.getAgreement());
-		for (ConnectionWithParty conn : state.getConnections()) {
+		for (ProtocolToPartyConn conn : state.getConnections()) {
 			sendFinish(conn, finished);
 		}
-		notifyChange(new CurrentNegoState(state));
-	}
-
-	private void sendFinish(ConnectionWithParty connection, Inform finished) {
+		notifyListeners(new CurrentNegoState(state));
+	}
+
+	private void sendFinish(ProtocolToPartyConn connection, Inform finished) {
 		try {
 			connection.send(finished);
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 8)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 9)
@@ -16,6 +16,6 @@
 import geniusweb.progress.ProgressRounds;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithParties;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.session.DefaultSessionState;
 import geniusweb.protocol.session.SessionSettings;
@@ -42,5 +42,5 @@
 	 *                      occurred.
 	 */
-	public SAOPState(List<Action> actions, ConnectionWithParties conns,
+	public SAOPState(List<Action> actions, ProtocolToPartyConnections conns,
 			Progress progress, SessionSettings settings,
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
@@ -55,5 +55,5 @@
 	public SAOPState(SAOPSettings settings) {
 		this(Collections.emptyList(),
-				new ConnectionWithParties(Collections.emptyList()), null,
+				new ProtocolToPartyConnections(Collections.emptyList()), null,
 				settings, null, null);
 
@@ -82,5 +82,5 @@
 	/**
 	 * 
-	 * @param connection   the new {@link ConnectionWithParty}
+	 * @param connection   the new {@link ProtocolToPartyConn}
 	 * @param partyprofile the {@link PartyWithProfile} that is associated with
 	 *                     this state
@@ -91,8 +91,8 @@
 	 *         state currently indicate if that already happened or not.
 	 */
-	public SAOPState with(ConnectionWithParty connection,
+	public SAOPState with(ProtocolToPartyConn connection,
 			PartyWithProfile partyprofile) {
 		// Only called from the SAOP initialization phase.
-		ConnectionWithParties newconns = getConnections().with(connection);
+		ProtocolToPartyConnections newconns = getConnections().with(connection);
 		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
 				getPartyProfiles());
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 8)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 9)
@@ -7,5 +7,5 @@
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.SessionResult;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -29,5 +29,5 @@
 	private final transient Reporter log;
 
-	private ConnectionWithPartyFactory connectionFactory; // FINAL
+	private ProtocolToPartyConnFactory connectionFactory; // FINAL
 	private AllPermutationsState state; // MUTABLE
 
@@ -45,7 +45,7 @@
 
 	@Override
-	public void start(ConnectionWithPartyFactory connectionfactory) {
+	public void start(ProtocolToPartyConnFactory connectionfactory) {
 		this.connectionFactory = connectionfactory;
-		notifyChange(new TournamentStarted(state.getSize().longValue()));
+		notifyListeners(new TournamentStarted(state.getSize().longValue()));
 		startNextSession();
 	}
@@ -85,5 +85,5 @@
 						sessionstate.getAgreement(), sessionstate.getError());
 				state = state.with(result);
-				notifyChange(new CurrentNegoState(state));
+				notifyListeners(new CurrentNegoState(state));
 				if (!state.isFinal(now)) {
 					startNextSession();
